# Hunter's Cron Jobs Addon
#  
# Install instructions:
#       1. Install Mattie's EventScripts 2.0 plugin:
#           http://mattie.info/cs/
#
#       2. Copy and upload this script to:
#           <gamedir>/addons/eventscripts/cron_jobs/
#
#       3. Add the following line somewhere in autoexec.cfg:
#           es_load cron_jobs
#
################################################################################
#import EventScripts
import es
#import Libraries
import os
import time
import gamethread
import keyvalues
#import Psyco Compiler
import psyco
psyco.full()

# Addon Information
info = es.AddonInfo()
info.name = "Cron Jobs"
info.version = "3.0.0"
info.author = "Hunter"
info.url = "http://addons.eventscripts.com/addons/user/289"
info.description = "Taskplaner for console commands"
info.basename = "cron_jobs"

hunter_cron_jobs_ver    = info.version
hunter_cron_jobs_text   = 'Hunters '+info.name+', www.sourceplugins.de, '+info.version+', ES 2.0.0.247+ (Python Version)'

# Global variables
cron_jobs_jobfile       = es.getAddonPath('cron_jobs') + '/cron_jobs.txt'
cron_jobs_joblist       = keyvalues.KeyValues(name='cron_jobs')

def load():
    public = es.ServerVar('hu_cj', info.version, info.name)
    public.makepublic()
    
    if os.path.exists(cron_jobs_jobfile):
        cron_jobs_joblist.load(cron_jobs_jobfile)
    if not 'joblist' in cron_jobs_joblist:
        cron_jobs_joblist['joblist'] = keyvalues.KeyValues(name='joblist')
    if not 'jobformats' in cron_jobs_joblist:
        cron_jobs_joblist['jobformats'] = keyvalues.KeyValues(name='jobformats')
        cron_jobs_joblist['jobformats']['%H:%M'] = 1
        cron_jobs_joblist['jobformats']['%H:%M:%S'] = 1
        cron_jobs_joblist['jobformats']['%y-%m-%d'] = 1
        cron_jobs_joblist['jobformats']['%y-%m-%d_%H:%M'] = 1
        cron_jobs_joblist['jobformats']['%y-%m-%d_%H:%M:%S'] = 1
        cron_jobs_joblist['jobformats']['%A_%H:%M'] = 1
        cron_jobs_joblist['jobformats']['%A_%H:%M:%S'] = 1
        cron_jobs_joblist['jobformats']['%B_%H:%M'] = 1
        cron_jobs_joblist['jobformats']['%B_%H:%M:%S'] = 1
    if len(cron_jobs_joblist['joblist'].keys()) > 0:
        gamethread.delayedname(1, 'cron_jobs', _run_jobs, (round(time.time(), 0)))

    es.log(hunter_cron_jobs_text)
    es.msg('#multi', '#green[CronJobs] #defaultLoaded')
    
def unload():
    if len(cron_jobs_joblist['joblist'].keys()) > 0:
        gamethread.cancelDelayed('cron_jobs')

    es.msg('#multi', '#green[CronJobs] #defaultUnloaded') 

def es_client_command(event_var):
    if (str(event_var['command']) == '!hunter_cron_jobs_ver') or (str(event_var['command']) == '!hunter_all_ver'):
        es.cexec(int(event_var['userid']), 'echo '+hunter_cron_jobs_text)

def player_activate(event_var):
    gamethread.delayed(30, es.cexec, (int(event_var['userid']), 'echo '+hunter_cron_jobs_text))

def _run_jobs(timestamp):
    gamethread.delayedname(1, 'cron_jobs', _run_jobs, (round(time.time(), 0)))
    if timestamp != round(time.time(), 0):
        # create the timestamps
        jobtimelist = []
        for jobformat in cron_jobs_joblist['jobformats']:
            if int(cron_jobs_joblist['jobformats'][str(jobformat)]): 
                jobtimelist.append(time.strftime(str(jobformat)))
        # run the jobs
        for jobtime in cron_jobs_joblist['joblist']:
            if str(jobtime) in jobtimelist:
                jobcommand = str(cron_jobs_joblist['joblist'][str(jobtime)])
                if (';' in jobcommand):
                    jobcommandlist = jobcommand.split(';')
                    for jobcommand in jobcommandlist:
                        es.ServerCommand(jobcommand.strip())
                else:
                    es.ServerCommand(jobcommand.strip())
